// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hidehisa AKIYAMA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 3, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
//Using in CMU_TSUKUBA @Spring Robocup contest
/////////////////////////////////////////////////////////////////////

#ifndef CMU_TSUKUBA_BHV_SIDE_BREAKTHROUGH_H
#define CMU_TSUKUBA_BHV_SIDE_BREAKTHROUGH_H

#include <rcsc/player/soccer_action.h>
#include <rcsc/geom/vector_2d.h>
#include <rcsc/action/body_pass.h>

class Bhv_SideBreakThrough
    : public rcsc::SoccerBehavior {
public:	
    bool execute( rcsc::PlayerAgent * agent );
};

class Body_BreakThroughPass:public rcsc::Body_Pass
{
public:
	Body_BreakThroughPass(){};
	
	
	
public:
	static bool get_best_breakthrough_pass(const rcsc::WorldModel & world,
	rcsc::Vector2D * target_point,
	double * first_speed,
	int * receiver);
	
};

#endif
